#!/bin/sh
#Bug fix sugg. Mikaloj 
if [ -e ~/.switchonbt ]
then
	source ~/.switchonbt
fi

#validation 
# if connect mode is not discoverable, change it to connectable
# will be able to make sure in case of error in setting, then it will change 
# to connectable by default
if [ "$BTCONNECT_MODE" = "discoverable" ]
then
	echo Switching to discoverable mode
	if [ -z $BTDISC_TIMEOUT ]
	then
		echo Time out not to be set
	elif [[ "$BTDISC_TIMEOUT" != *[0-9] ]]
	then
		echo Discoverable time out is wrong, setting as 0
		BTDISC_TIMEOUT="0"
	fi
else
	echo Connect mode string is wrong. Mode will be set as connectable
	BTCONNECT_MODE="connectable"
fi

state=$(dbus-send --system --type=method_call --print-reply --dest=org.bluez /org/bluez/hci0 org.bluez.Adapter.GetMode | grep string | cut -d'"' -f2)
if [ "$state" = "" ]
then
	#error command failed
	echo "Error dbus-send failed"
elif [ "$state" = "off" ]
then
	dbus-send --system --type=method_call --dest=org.bluez /org/bluez/hci0 org.bluez.Adapter.SetMode string:$BTCONNECT_MODE
	if [ ! -z $BTDISC_TIMEOUT ]
	then
		dbus-send --system --type=method_call --dest=org.bluez /org/bluez/hci0 org.bluez.Adapter.SetDiscoverableTimeout uint32:$BTDISC_TIMEOUT
	fi
else 
	dbus-send --system --type=method_call --dest=org.bluez /org/bluez/hci0 org.bluez.Adapter.SetMode string:off
fi
